// http://zx-pk.ru/showthread.php?t=19960 //

#include <stdio.h>
#include <windows.h>   
#include "vsm.hpp"   

#define SIZE_X  920
#define SIZE_Y  640

/********************************************************************/

class DISPLAY : public IACTIVEMODEL,public IDSIMMODEL 
{ 
public: 
  int isdigital (CHAR *pinname); 
  void setup (IINSTANCE *inst, IDSIMCKT *dsim); 
  void runctrl (RUNMODES mode); 
  void actuate (REALTIME time, ACTIVESTATE newstate); 
  BOOL indicate (REALTIME time, ACTIVEDATA *data); 
  void simulate (ABSTIME time, DSIMMODES mode); 
  void callback (ABSTIME time, EVENTID eventid); 
  void initialize (ICOMPONENT *cpt); 
  ISPICEMODEL *getspicemodel (CHAR *device); 
  IDSIMMODEL *getdsimmodel (CHAR *device); 
  void plot (ACTIVESTATE state); 
  void animate (INT element, ACTIVEDATA *newstate); 
  BOOL actuate (WORD key, INT x, INT y, DWORD flags); 
 
private: 
  IINSTANCE *instance;  
  IDSIMCKT *ckt;      
  ICOMPONENT *component;   
  IDSIMPIN *en_video; 
  IDSIMPIN *en_sync_h; 
  IDSIMPIN *en_sync_v; 
  IDSIMPIN *en_pclk; 
}; 

HANDLE hProcessHeap;
HDC dc,buffer;
HBITMAP bmp;
PCHAR lin,slin;
int fsize=0,lsize=0;
BOOL vst, hst, plst,fcn;
HWND hpupwnd=0;              
BITMAPINFO bmi;

IUSERPOPUP  *pup;
IMSGHLR * cbf;




extern "C" IDSIMMODEL __declspec(dllexport)*createdsimmodel(CHAR *device,ILICENCESERVER *ils)   {     
        ils->authorize(0x88888888, 0x69);  
        return new DISPLAY;   
}   
       

extern "C" VOID __declspec(dllexport)deletedsimmodel(IDSIMMODEL*model)   {   
    HeapFree(hProcessHeap,0,lin);
    HeapFree(hProcessHeap,0,slin);
    delete (DISPLAY*)model; 
	if (pup!=NULL) delete cbf;
	delete pup;
}   
       
       
int DISPLAY::isdigital(CHAR *pinname)   {   
        return 1;   
}   

class WINCB : public IMSGHLR
{
public:
	LRESULT msghlr(HWND, MESSAGE, WPARAM, LPARAM);

};

LRESULT WINCB::msghlr(HWND hwnd, MESSAGE msg, WPARAM wParam, LPARAM lParam)
{
	if (!hpupwnd)
	{
		hpupwnd = hwnd;

		dc = GetDC(hwnd);
		buffer = CreateCompatibleDC(dc);
		ReleaseDC(hwnd, dc);

		bmi.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);

		bmi.bmiHeader.biWidth = SIZE_X;
		bmi.bmiHeader.biHeight = -SIZE_Y;
		bmi.bmiHeader.biPlanes = 1;
		bmi.bmiHeader.biBitCount = 8;
		bmi.bmiHeader.biCompression = BI_RGB;
		bmi.bmiHeader.biSizeImage = 0;
		bmi.bmiHeader.biXPelsPerMeter = 0;
		bmi.bmiHeader.biYPelsPerMeter = 0;
		bmi.bmiHeader.biClrUsed = 0;
		bmi.bmiHeader.biClrImportant = 0;



		bmi.bmiColors[0xda].rgbBlue = 0;
		bmi.bmiColors[0xda].rgbGreen = 0;
		bmi.bmiColors[0xda].rgbRed = 0;
		bmi.bmiColors[0xda].rgbReserved = 0;

		bmi.bmiColors[0x45].rgbBlue = 200;
		bmi.bmiColors[0x45].rgbGreen = 200;
		bmi.bmiColors[0x45].rgbRed = 160;
		bmi.bmiColors[0x45].rgbReserved = 0;

		bmi.bmiColors[0x82].rgbBlue = 100;
		bmi.bmiColors[0x82].rgbGreen = 50;
		bmi.bmiColors[0x82].rgbRed = 50;
		bmi.bmiColors[0x82].rgbReserved = 0;

		bmp = CreateDIBSection(buffer, &bmi, DIB_RGB_COLORS, (void**)slin, NULL, 0);

		SelectObject(buffer, bmp);
	}

	return pup->callwindowproc(msg, wParam, lParam);
}

/********************************************************************/

void DISPLAY::setup(IINSTANCE *inst,IDSIMCKT *dsim)   {   
    instance = inst;    
          ckt = dsim;     
        
//		instance->log("START");
    hProcessHeap=GetProcessHeap();
    lin=(PCHAR)HeapAlloc(hProcessHeap, 0, SIZE_X*10*SIZE_Y); 
    slin=(PCHAR)HeapAlloc(hProcessHeap, 0, SIZE_X*10*SIZE_Y); 
    
 	CREATEPOPUPSTRUCT *cp=new CREATEPOPUPSTRUCT;
	cp->caption = "VGA SCREEN";
	cp->id = 0;
	cp->type = PWT_USER;
	cp->flags = PWF_VISIBLE; // | PWF_AUTOREFRESH;
	cp->width = SIZE_X;
	cp->height = SIZE_Y;

	pup = (IUSERPOPUP*)instance->createpopup(cp);
	if (pup!=NULL)
	{
	cbf = new WINCB;
	pup->setmsghlr(cbf);
	}		
    vst=0;
    hst=0;
	plst=0;
	fcn=0;
    en_video = instance->getdsimpin("VIDEO,video", true);   
        en_video->setstate(FLT);   
    en_sync_h = instance->getdsimpin("SYNC_H", true);   
        en_sync_h->setstate(FLT);   
    en_sync_v = instance->getdsimpin("SYNC_V", true);   
        en_sync_v->setstate(FLT);   
    en_pclk = instance->getdsimpin("PCLK", true);   
        en_pclk->setstate(FLT);   
        
}   
       
void DISPLAY::runctrl(RUNMODES mode)  {   
//       		instance->log("mode %d",mode);

}   
       
       
void DISPLAY::actuate(REALTIME time,ACTIVESTATE newstate) {   
//	MessageBox(0, "ACTUATE 1", "Break", MB_OK);

}   
       
BOOL DISPLAY::indicate(REALTIME time,ACTIVEDATA *data)   {      
//		instance->log("indicate");
	SetBitmapBits(bmp, SIZE_X*SIZE_Y, lin);
	dc = GetDC(hpupwnd);
	BitBlt(dc, 0, 0, SIZE_X, SIZE_Y, buffer, 0, 0, SRCCOPY);
	ReleaseDC(hpupwnd, dc);
	return TRUE;
}   
       
       
void DISPLAY::simulate (ABSTIME time,DSIMMODES mode) {      
	int i;
    UCHAR c;
	if (!en_pclk->isedge()) return;
    BOOL st_v=ishigh(en_video->istate());
    BOOL st_sh=ishigh(en_sync_h->istate());
    BOOL st_sv=ishigh(en_sync_v->istate());
    BOOL st_pc=ishigh(en_pclk->istate());
//       		instance->log("mode %d",mode);

//	if (plst==st_pc) return;
//	plst=st_pc;

  if (!st_sh)
    {
      if (hst==0)
      {
      if (fcn<4) fcn++;
      if (fcn<3)
       {
       c=0xda;
       memset(lin,c,SIZE_X*SIZE_Y);
       SetBitmapBits(bmp,SIZE_X*SIZE_Y,lin);
       SelectObject(buffer,bmp);
       BitBlt(dc,0,0,SIZE_X,SIZE_Y,buffer,0,0,SRCCOPY);
       }
      fsize=0;
      hst=1;
      }
    }
    else
    {
      hst=0;
    if (!st_sv)
      {
      if (vst==0)
       {
       lsize=0;
       c=0x45;
       memset(lin+fsize+SIZE_X,c,SIZE_X);
         SetBitmapBits(bmp,SIZE_X*SIZE_Y,lin);
       SelectObject(buffer,bmp);
       BitBlt(dc,0,0,SIZE_X,SIZE_Y,buffer,0,0,SRCCOPY);
       vst=1;
       fsize+=SIZE_X;
       }
      }
     else
      {
      vst=0;
      if (!st_pc)
        {
        if (st_v) c=0x45; else c=0xda;
        memset(lin+fsize+lsize,c,2);
        lsize+=2;
        }
      }
    }

/*
	if (!st_sh)
    {
      if (!hst)
      {
	     fsize=0;
	     hst=1;
      }
    }
    else
    {
      hst=0;
    if (!st_sv)
      {
      if (vst==0)
       {
       lsize=0;
	   vst=1;
//		instance->log("SIM %d",fsize);
       fsize+=SIZE_X;
	   if (fsize>=SIZE_X*SIZE_Y) fsize=0;
	   for (i=0;i<SIZE_X;i++) {
       *(lin + fsize + SIZE_X + i) = 0xda;
       *(lin + fsize + SIZE_X*2 + i) = 0x45;
	   }
       }
      }
     else
      {
      vst=0;
      if (!st_pc)
        {
        if (st_v) c=0x45; else c=0xda;
		*(lin + fsize + lsize + SIZE_X) = c;
		lsize++;
//		instance->log("ind %d",lsize);
		//if (lsize<SIZE_X) lsize++;
        }
      }
    }
	*/
}   
       
      
void DISPLAY::callback(ABSTIME time,EVENTID eventid)   {   
//	MessageBox(0, "callback", "Break", MB_OK);

}   
              
extern "C" IACTIVEMODEL __declspec(dllexport)*createactivemodel(CHAR *device,ILICENCESERVER *ils)  {    
        ils->authorize (0);     
        return new DISPLAY;   
}   
              
extern "C" VOID  __declspec(dllexport)deleteactivemodel (IACTIVEMODEL *model)  {    
    
    
  delete (DISPLAY*)model;   
}   
               
void DISPLAY::initialize(ICOMPONENT *cpt)  {    

}   
               
ISPICEMODEL *DISPLAY::getspicemodel(CHAR *)  {    
        return NULL;    
}   
       
IDSIMMODEL  *DISPLAY::getdsimmodel(CHAR *)  {      
        return this;    
}   

void DISPLAY::plot(ACTIVESTATE state)  {   

//	MessageBox(0, "plot", "Break", MB_OK);
}
        
void DISPLAY::animate(INT element, ACTIVEDATA *data)  {    
//	MessageBox(0, "animate", "Break", MB_OK);

}   

BOOL DISPLAY::actuate(WORD key, INT x, INT y, DWORD flags)  {
//	MessageBox(0, "ACTUATE2", "Break", MB_OK);
        return FALSE;    
}  
