#include <stdio.h>
#include <windows.h>   
#include "vsm.hpp"   

/********************************************************************/

class I8255 : public IACTIVEMODEL,public IDSIMMODEL 
{ 
public: 
  int isdigital (CHAR *pinname); 
  void setup (IINSTANCE *inst, IDSIMCKT *dsim); 
  void runctrl (RUNMODES mode); 
  void actuate (REALTIME time, ACTIVESTATE newstate); 
  BOOL indicate (REALTIME time, ACTIVEDATA *data); 
  void simulate (ABSTIME time, DSIMMODES mode); 
  void callback (ABSTIME time, EVENTID eventid); 
  void initialize (ICOMPONENT *cpt); 
  ISPICEMODEL *getspicemodel (CHAR *device); 
  IDSIMMODEL *getdsimmodel (CHAR *device); 
  void plot (ACTIVESTATE state); 
  void animate (INT element, ACTIVEDATA *newstate); 
  BOOL actuate (WORD key, INT x, INT y, DWORD flags); 
  unsigned char control;
  unsigned char portA_data;
  unsigned char portB_data;
  unsigned char portC_data;

private: 
 unsigned char get_data();
 unsigned char get_portA_data();
 unsigned char get_portB_data();
 unsigned char get_portC_data();
 void set_data(ABSTIME time,unsigned char tmp);
 void set_data_Z(ABSTIME time);
 void set_portA_Z(ABSTIME time);
 void set_portB_Z(ABSTIME time);
 void set_portC_lo_Z(ABSTIME time);
 void set_portC_hi_Z(ABSTIME time);
 void set_portA(ABSTIME time,unsigned char tmp);
 void set_portB(ABSTIME time,unsigned char tmp);
 void set_portC(ABSTIME time,unsigned char tmp);
 void set_data_ports(ABSTIME time);
  IINSTANCE *instance;  
  IDSIMCKT *ckt;      
  ICOMPONENT *component;   
  IDSIMPIN *pin_cs; 
  IDSIMPIN *pin_rd; 
  IDSIMPIN *pin_wr; 
  IDSIMPIN *pin_reset; 
  IDSIMPIN *pin_A0; 
  IDSIMPIN *pin_A1; 
  IDSIMPIN *pin_D0; 
  IDSIMPIN *pin_D1; 
  IDSIMPIN *pin_D2; 
  IDSIMPIN *pin_D3; 
  IDSIMPIN *pin_D4; 
  IDSIMPIN *pin_D5; 
  IDSIMPIN *pin_D6; 
  IDSIMPIN *pin_D7; 
  IDSIMPIN *pin_PA0; 
  IDSIMPIN *pin_PA1; 
  IDSIMPIN *pin_PA2; 
  IDSIMPIN *pin_PA3; 
  IDSIMPIN *pin_PA4; 
  IDSIMPIN *pin_PA5; 
  IDSIMPIN *pin_PA6; 
  IDSIMPIN *pin_PA7; 
  IDSIMPIN *pin_PB0; 
  IDSIMPIN *pin_PB1; 
  IDSIMPIN *pin_PB2; 
  IDSIMPIN *pin_PB3; 
  IDSIMPIN *pin_PB4; 
  IDSIMPIN *pin_PB5; 
  IDSIMPIN *pin_PB6; 
  IDSIMPIN *pin_PB7; 
  IDSIMPIN *pin_PC0; 
  IDSIMPIN *pin_PC1; 
  IDSIMPIN *pin_PC2; 
  IDSIMPIN *pin_PC3; 
  IDSIMPIN *pin_PC4; 
  IDSIMPIN *pin_PC5; 
  IDSIMPIN *pin_PC6; 
  IDSIMPIN *pin_PC7; 
}; 

HANDLE hProcessHeap;

extern "C" IDSIMMODEL __declspec(dllexport)*createdsimmodel(CHAR *device,ILICENCESERVER *ils)   {     
        ils->authorize(0x88888888, 0x69);  
        return new I8255;   
}   

extern "C" VOID __declspec(dllexport)deletedsimmodel(IDSIMMODEL*model)   {   
    delete (I8255*)model; 
}   
       
int I8255::isdigital(CHAR *pinname)   {   
        return 1;   
}   

/********************************************************************/

void I8255::setup(IINSTANCE *inst,IDSIMCKT *dsim)   {   
    instance = inst;    
          ckt = dsim;     
        
//		instance->log("START");
    hProcessHeap=GetProcessHeap();
  
	control=0x9b;
	portA_data=0xff;
	portB_data=0xff;
	portC_data=0xff;

    pin_cs = instance->getdsimpin("$CS$", true); pin_cs->setstate(0,1,FLT);   
    pin_rd = instance->getdsimpin("$RD$", true); pin_rd->setstate(0,1,FLT);   
    pin_wr = instance->getdsimpin("$WR$", true); pin_wr->setstate(0,1,FLT);   
    pin_reset = instance->getdsimpin("RESET", true);   pin_reset->setstate(0,1,FLT);   
    pin_A0 = instance->getdsimpin("A0", true);   pin_A0->setstate(0,1,FLT);   
    pin_A1 = instance->getdsimpin("A1", true);   pin_A1->setstate(0,1,FLT);   
    pin_D0 = instance->getdsimpin("D0", true);   
    pin_D1 = instance->getdsimpin("D1", true);   
    pin_D2 = instance->getdsimpin("D2", true);   
    pin_D3 = instance->getdsimpin("D3", true);   
    pin_D4 = instance->getdsimpin("D4", true);   
    pin_D5 = instance->getdsimpin("D5", true);   
    pin_D6 = instance->getdsimpin("D6", true);   
    pin_D7 = instance->getdsimpin("D7", true);   set_data_Z(0);
    pin_PA0 = instance->getdsimpin("PA0", true);   
    pin_PA1 = instance->getdsimpin("PA1", true);   
    pin_PA2 = instance->getdsimpin("PA2", true);   
    pin_PA3 = instance->getdsimpin("PA3", true);   
    pin_PA4 = instance->getdsimpin("PA4", true);   
    pin_PA5 = instance->getdsimpin("PA5", true);   
    pin_PA6 = instance->getdsimpin("PA6", true);   
    pin_PA7 = instance->getdsimpin("PA7", true);   set_portA_Z(0);
    pin_PB0 = instance->getdsimpin("PB0", true);   
    pin_PB1 = instance->getdsimpin("PB1", true);   
    pin_PB2 = instance->getdsimpin("PB2", true);   
    pin_PB3 = instance->getdsimpin("PB3", true);   
    pin_PB4 = instance->getdsimpin("PB4", true);   
    pin_PB5 = instance->getdsimpin("PB5", true);   
    pin_PB6 = instance->getdsimpin("PB6", true);   
    pin_PB7 = instance->getdsimpin("PB7", true);   set_portB_Z(0);
    pin_PC0 = instance->getdsimpin("PC0", true);   
    pin_PC1 = instance->getdsimpin("PC1", true);   
    pin_PC2 = instance->getdsimpin("PC2", true);   
    pin_PC3 = instance->getdsimpin("PC3", true);   set_portC_lo_Z(0);
    pin_PC4 = instance->getdsimpin("PC4", true);   
    pin_PC5 = instance->getdsimpin("PC5", true);   
    pin_PC6 = instance->getdsimpin("PC6", true);   
    pin_PC7 = instance->getdsimpin("PC7", true);   set_portC_hi_Z(0);
    
}   
       
void I8255::runctrl(RUNMODES mode)  {   

}   
       
       
void I8255::actuate(REALTIME time,ACTIVESTATE newstate) {   

}   
       
BOOL I8255::indicate(REALTIME time,ACTIVEDATA *data)   {      
	return TRUE;
}   
       
void I8255::set_data_Z(ABSTIME time)
{
 pin_D0->setstate(time,1,FLT);   
 pin_D1->setstate(time,1,FLT);   
 pin_D2->setstate(time,1,FLT);   
 pin_D3->setstate(time,1,FLT);   
 pin_D4->setstate(time,1,FLT);   
 pin_D5->setstate(time,1,FLT);   
 pin_D6->setstate(time,1,FLT);   
 pin_D7->setstate(time,1,FLT);   
}

void I8255::set_portA_Z(ABSTIME time)
{
 pin_PA0->setstate(time,1,FLT);   
 pin_PA1->setstate(time,1,FLT);   
 pin_PA2->setstate(time,1,FLT);   
 pin_PA3->setstate(time,1,FLT);   
 pin_PA4->setstate(time,1,FLT);   
 pin_PA5->setstate(time,1,FLT);   
 pin_PA6->setstate(time,1,FLT);   
 pin_PA7->setstate(time,1,FLT);   
}

void I8255::set_portB_Z(ABSTIME time)
{
 pin_PB0->setstate(time,1,FLT);   
 pin_PB1->setstate(time,1,FLT);   
 pin_PB2->setstate(time,1,FLT);   
 pin_PB3->setstate(time,1,FLT);   
 pin_PB4->setstate(time,1,FLT);   
 pin_PB5->setstate(time,1,FLT);   
 pin_PB6->setstate(time,1,FLT);   
 pin_PB7->setstate(time,1,FLT);   
}

void I8255::set_portC_lo_Z(ABSTIME time)
{
 pin_PC0->setstate(time,1,FLT);   
 pin_PC1->setstate(time,1,FLT);   
 pin_PC2->setstate(time,1,FLT);   
 pin_PC3->setstate(time,1,FLT);   
}

void I8255::set_portC_hi_Z(ABSTIME time)
{
 pin_PC4->setstate(time,1,FLT);   
 pin_PC5->setstate(time,1,FLT);   
 pin_PC6->setstate(time,1,FLT);   
 pin_PC7->setstate(time,1,FLT);   
}

unsigned char I8255::get_portA_data()
{
unsigned char tmp=0;
 if (ishigh(pin_PA0->istate())) tmp|=0x01;
 if (ishigh(pin_PA1->istate())) tmp|=0x02;
 if (ishigh(pin_PA2->istate())) tmp|=0x04;
 if (ishigh(pin_PA3->istate())) tmp|=0x08;
 if (ishigh(pin_PA4->istate())) tmp|=0x10;
 if (ishigh(pin_PA5->istate())) tmp|=0x20;
 if (ishigh(pin_PA6->istate())) tmp|=0x40;
 if (ishigh(pin_PA7->istate())) tmp|=0x80;
 return tmp;
}

unsigned char I8255::get_portB_data()
{
unsigned char tmp=0;
 if (ishigh(pin_PB0->istate())) tmp|=0x01;
 if (ishigh(pin_PB1->istate())) tmp|=0x02;
 if (ishigh(pin_PB2->istate())) tmp|=0x04;
 if (ishigh(pin_PB3->istate())) tmp|=0x08;
 if (ishigh(pin_PB4->istate())) tmp|=0x10;
 if (ishigh(pin_PB5->istate())) tmp|=0x20;
 if (ishigh(pin_PB6->istate())) tmp|=0x40;
 if (ishigh(pin_PB7->istate())) tmp|=0x80;
 return tmp;
}

unsigned char I8255::get_portC_data()
{
unsigned char tmp=0;
 if (ishigh(pin_PC0->istate())) tmp|=0x01;
 if (ishigh(pin_PC1->istate())) tmp|=0x02;
 if (ishigh(pin_PC2->istate())) tmp|=0x04;
 if (ishigh(pin_PC3->istate())) tmp|=0x08;
 if (ishigh(pin_PC4->istate())) tmp|=0x10;
 if (ishigh(pin_PC5->istate())) tmp|=0x20;
 if (ishigh(pin_PC6->istate())) tmp|=0x40;
 if (ishigh(pin_PC7->istate())) tmp|=0x80;
 return tmp;
}

unsigned char I8255::get_data()
{
unsigned char tmp=0;
 if (ishigh(pin_D0->istate())) tmp|=0x01;
 if (ishigh(pin_D1->istate())) tmp|=0x02;
 if (ishigh(pin_D2->istate())) tmp|=0x04;
 if (ishigh(pin_D3->istate())) tmp|=0x08;
 if (ishigh(pin_D4->istate())) tmp|=0x10;
 if (ishigh(pin_D5->istate())) tmp|=0x20;
 if (ishigh(pin_D6->istate())) tmp|=0x40;
 if (ishigh(pin_D7->istate())) tmp|=0x80;
 return tmp;
}

void I8255::set_data(ABSTIME time,unsigned char tmp)
{
	if (tmp&0x01) pin_D0->setstate(time,1,SHI); else pin_D0->setstate(time,1,SLO);
	if (tmp&0x02) pin_D1->setstate(time,1,SHI); else pin_D1->setstate(time,1,SLO);
	if (tmp&0x04) pin_D2->setstate(time,1,SHI); else pin_D2->setstate(time,1,SLO);
	if (tmp&0x08) pin_D3->setstate(time,1,SHI); else pin_D3->setstate(time,1,SLO);
	if (tmp&0x10) pin_D4->setstate(time,1,SHI); else pin_D4->setstate(time,1,SLO);
	if (tmp&0x20) pin_D5->setstate(time,1,SHI); else pin_D5->setstate(time,1,SLO);
	if (tmp&0x40) pin_D6->setstate(time,1,SHI); else pin_D6->setstate(time,1,SLO);
	if (tmp&0x80) pin_D7->setstate(time,1,SHI); else pin_D7->setstate(time,1,SLO);
}

void I8255::set_portA(ABSTIME time,unsigned char tmp)
{
	if (tmp&0x01) pin_PA0->setstate(time,1,SHI); else pin_PA0->setstate(time,1,SLO);
	if (tmp&0x02) pin_PA1->setstate(time,1,SHI); else pin_PA1->setstate(time,1,SLO);
	if (tmp&0x04) pin_PA2->setstate(time,1,SHI); else pin_PA2->setstate(time,1,SLO);
	if (tmp&0x08) pin_PA3->setstate(time,1,SHI); else pin_PA3->setstate(time,1,SLO);
	if (tmp&0x10) pin_PA4->setstate(time,1,SHI); else pin_PA4->setstate(time,1,SLO);
	if (tmp&0x20) pin_PA5->setstate(time,1,SHI); else pin_PA5->setstate(time,1,SLO);
	if (tmp&0x40) pin_PA6->setstate(time,1,SHI); else pin_PA6->setstate(time,1,SLO);
	if (tmp&0x80) pin_PA7->setstate(time,1,SHI); else pin_PA7->setstate(time,1,SLO);
}

void I8255::set_portB(ABSTIME time,unsigned char tmp)
{
	if (tmp&0x01) pin_PB0->setstate(time,1,SHI); else pin_PB0->setstate(time,1,SLO);
	if (tmp&0x02) pin_PB1->setstate(time,1,SHI); else pin_PB1->setstate(time,1,SLO);
	if (tmp&0x04) pin_PB2->setstate(time,1,SHI); else pin_PB2->setstate(time,1,SLO);
	if (tmp&0x08) pin_PB3->setstate(time,1,SHI); else pin_PB3->setstate(time,1,SLO);
	if (tmp&0x10) pin_PB4->setstate(time,1,SHI); else pin_PB4->setstate(time,1,SLO);
	if (tmp&0x20) pin_PB5->setstate(time,1,SHI); else pin_PB5->setstate(time,1,SLO);
	if (tmp&0x40) pin_PB6->setstate(time,1,SHI); else pin_PB6->setstate(time,1,SLO);
	if (tmp&0x80) pin_PB7->setstate(time,1,SHI); else pin_PB7->setstate(time,1,SLO);
}

void I8255::set_portC(ABSTIME time,unsigned char tmp)
{
	if (tmp&0x01) pin_PC0->setstate(time,1,SHI); else pin_PC0->setstate(time,1,SLO);
	if (tmp&0x02) pin_PC1->setstate(time,1,SHI); else pin_PC1->setstate(time,1,SLO);
	if (tmp&0x04) pin_PC2->setstate(time,1,SHI); else pin_PC2->setstate(time,1,SLO);
	if (tmp&0x08) pin_PC3->setstate(time,1,SHI); else pin_PC3->setstate(time,1,SLO);
	if (tmp&0x10) pin_PC4->setstate(time,1,SHI); else pin_PC4->setstate(time,1,SLO);
	if (tmp&0x20) pin_PC5->setstate(time,1,SHI); else pin_PC5->setstate(time,1,SLO);
	if (tmp&0x40) pin_PC6->setstate(time,1,SHI); else pin_PC6->setstate(time,1,SLO);
	if (tmp&0x80) pin_PC7->setstate(time,1,SHI); else pin_PC7->setstate(time,1,SLO);
}

void I8255::set_data_ports(ABSTIME time)
{
	set_portA(time,portA_data);
	set_portB(time,portB_data);
	set_portC(time,portC_data);
		switch(control)
		{
		case 0x80:
			break;
		case 0x81:
			set_portC_lo_Z(time);
			break;
		case 0x82:
			set_portB_Z(time);
			break;
		case 0x83:
			set_portB_Z(time);
			set_portC_lo_Z(time);
			break;
		case 0x88:
			set_portC_hi_Z(time);
			break;
		case 0x89:
			set_portC_lo_Z(time);
			set_portC_hi_Z(time);
			break;
		case 0x8a:
			set_portA(time,portA_data);
			set_portC(time,portC_data);
			set_portB_Z(time);
			set_portC_hi_Z(time);
			break;
		case 0x8b:
			set_portB_Z(time);
			set_portC_lo_Z(time);
			set_portC_hi_Z(time);
			break;
		case 0x90:
			set_portA_Z(time);
			break;
		case 0x91:
			set_portA_Z(time);
			set_portC_lo_Z(time);
			break;
		case 0x92:
			set_portA_Z(time);
			set_portB_Z(time);
			break;
		case 0x93:
			set_portA_Z(time);
			set_portB_Z(time);
			set_portC_lo_Z(time);
			break;
		case 0x98:
			set_portA_Z(time);
			set_portC_hi_Z(time);
			break;
		case 0x99:
			set_portA_Z(time);
			set_portC_hi_Z(time);
			set_portC_lo_Z(time);
			break;
		case 0x9a:
			set_portA_Z(time);
			set_portB_Z(time);
			set_portC_hi_Z(time);
			break;
		case 0x9b:
			set_portA_Z(time);
			set_portB_Z(time);
			set_portC_hi_Z(time);
			set_portC_lo_Z(time);
			break;
		}
}

void I8255::simulate (ABSTIME time,DSIMMODES mode) {      
unsigned char tmp=0;
unsigned char mask[8]={0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80};

	if (ishigh(pin_cs->istate()))
	{//CS==1
		if (pin_cs->isedge()) 
		{//instance->log("CSedge CS 1");
		 set_data_Z(time);
		}
		return;
	}
	else
	{//CS==0
		if (ishigh(pin_A0->istate())) tmp|=0x01;
		if (ishigh(pin_A1->istate())) tmp|=0x02;
		if (ishigh(pin_rd->istate())) tmp|=0x04;
		if (ishigh(pin_wr->istate())) tmp|=0x08;
		if (pin_rd->isedge() | pin_wr->isedge())
		switch(tmp)
		{
		case 0x07: //write control  b0111
			tmp=get_data();
//	instance->log("set control %x  old control %x",tmp,control);
			if (tmp&0x80)
			{
			 control=tmp;
			 tmp=get_data();
			}
			else
			{ //portC individual pin
//	instance->log("set portC individual pin control %x",tmp);
				if (tmp&0x01) portC_data|=mask[(tmp/2)&0x07]; else portC_data&=~mask[(tmp/2)&0x07];
			}
			set_data_ports(time);
			break;
		case 0x0b: //read control   b1011
			//set_data(time,control); //undefined
//	instance->log("get control %x",control);
			break;
		case 0x04: // write PA   b0100
			portA_data=get_data();
//	instance->log("set PA %x",portA_data);
			set_data_ports(time);
			break;
		case 0x08: // read PA     b1000
			set_data(time,get_portA_data());
//	instance->log("get PA %x",get_portA_data());
			break;
		case 0x05: // write PB    b0101
			portB_data=get_data();
//	instance->log("set PB %x",get_data());
			set_data_ports(time);
			break;
		case 0x09: // read PB     b1001
			set_data(time,get_portB_data());
//	instance->log("get PB %x",get_portB_data());
			break;
		case 0x06: // write PC    b0110
			portC_data=get_data();
//	instance->log("set PC %x",portC_data);
			set_data_ports(time);
			break;
		case 0x0a: // read PC     b1010
			set_data(time,get_portC_data());
//	instance->log("get PC %x",get_portC_data());
			break;
		default:
			set_data_Z(time);
			break;
		}
	}
}   
       
      
void I8255::callback(ABSTIME time,EVENTID eventid)   {   

}   
              
extern "C" IACTIVEMODEL __declspec(dllexport)*createactivemodel(CHAR *device,ILICENCESERVER *ils)  {    
        ils->authorize (0);     
        return new I8255;   
}   
              
extern "C" VOID  __declspec(dllexport)deleteactivemodel (IACTIVEMODEL *model)  {    
    
    
  delete (I8255*)model;   
}   
               
void I8255::initialize(ICOMPONENT *cpt)  {    

}   
               
ISPICEMODEL *I8255::getspicemodel(CHAR *)  {    
        return NULL;    
}   
       
IDSIMMODEL  *I8255::getdsimmodel(CHAR *)  {      
        return this;    
}   

void I8255::plot(ACTIVESTATE state)  {   

//	MessageBox(0, "plot", "Break", MB_OK);
}
        
void I8255::animate(INT element, ACTIVEDATA *data)  {    
//	MessageBox(0, "animate", "Break", MB_OK);

}   

BOOL I8255::actuate(WORD key, INT x, INT y, DWORD flags)  {
//	MessageBox(0, "ACTUATE2", "Break", MB_OK);
        return FALSE;    
}  
