#include <stdio.h>
#include <windows.h>   
#include "vsm.hpp"   

/********************************************************************/

class I8257 : public IACTIVEMODEL,public IDSIMMODEL 
{ 
public: 
  int isdigital (CHAR *pinname); 
  void setup (IINSTANCE *inst, IDSIMCKT *dsim); 
  void runctrl (RUNMODES mode); 
  void actuate (REALTIME time, ACTIVESTATE newstate); 
  BOOL indicate (REALTIME time, ACTIVEDATA *data); 
  void simulate (ABSTIME time, DSIMMODES mode); 
  void callback (ABSTIME time, EVENTID eventid); 
  void initialize (ICOMPONENT *cpt); 
  ISPICEMODEL *getspicemodel (CHAR *device); 
  IDSIMMODEL *getdsimmodel (CHAR *device); 
  void plot (ACTIVESTATE state); 
  void animate (INT element, ACTIVEDATA *newstate); 
  BOOL actuate (WORD key, INT x, INT y, DWORD flags); 
  unsigned char takt;
  unsigned char mode_reg;
  unsigned char status_reg;
  unsigned char cnt_cs;
  unsigned char ch_adr0[2];
  unsigned char ch_cnt0[2];
  unsigned char ch_adr1[2];
  unsigned char ch_cnt1[2];
  unsigned char ch_adr2[2];
  unsigned char ch_cnt2[2];
  unsigned char ch_adr3[2];
  unsigned char ch_cnt3[2];
  
private: 
 unsigned char get_data();
 void set_data(ABSTIME time,unsigned char tmp);
 void set_data_Z(ABSTIME time);
 void set_adr(ABSTIME time,unsigned char tmp);
 void set_adr_Z(ABSTIME time);
  IINSTANCE *instance;  
  IDSIMCKT *ckt;      
  ICOMPONENT *component;   
  IDSIMPIN *pin_CLK; 
  IDSIMPIN *pin_HOLD; 
  IDSIMPIN *pin_HLDA; 
  IDSIMPIN *pin_cs; 
  IDSIMPIN *pin_nIORd; 
  IDSIMPIN *pin_nIOWr; 
  IDSIMPIN *pin_nMEMR; 
  IDSIMPIN *pin_nMEMW; 
  IDSIMPIN *pin_reset; 
  IDSIMPIN *pin_A0; 
  IDSIMPIN *pin_A1; 
  IDSIMPIN *pin_A2; 
  IDSIMPIN *pin_A3; 
  IDSIMPIN *pin_A4; 
  IDSIMPIN *pin_A5; 
  IDSIMPIN *pin_A6; 
  IDSIMPIN *pin_A7; 
  IDSIMPIN *pin_ADSTB; 
  IDSIMPIN *pin_AEN; 
  IDSIMPIN *pin_D0; 
  IDSIMPIN *pin_D1; 
  IDSIMPIN *pin_D2; 
  IDSIMPIN *pin_D3; 
  IDSIMPIN *pin_D4; 
  IDSIMPIN *pin_D5; 
  IDSIMPIN *pin_D6; 
  IDSIMPIN *pin_D7; 
  IDSIMPIN *pin_DRQ0; 
  IDSIMPIN *pin_DRQ1; 
  IDSIMPIN *pin_DRQ2; 
  IDSIMPIN *pin_DRQ3; 
  IDSIMPIN *pin_nDACK0; 
  IDSIMPIN *pin_nDACK1; 
  IDSIMPIN *pin_nDACK2; 
  IDSIMPIN *pin_nDACK3; 
  IDSIMPIN *pin_MARK; 
  IDSIMPIN *pin_TC; 
  IDSIMPIN *pin_READY; 
}; 

HANDLE hProcessHeap;

extern "C" IDSIMMODEL __declspec(dllexport)*createdsimmodel(CHAR *device,ILICENCESERVER *ils)   {     
        ils->authorize(0x88888888, 0x69);  
        return new I8257;   
}   

extern "C" VOID __declspec(dllexport)deletedsimmodel(IDSIMMODEL*model)   {   
    delete (I8257*)model; 
}   
       
int I8257::isdigital(CHAR *pinname)   {   
        return 1;   
}   

/********************************************************************/

void I8257::setup(IINSTANCE *inst,IDSIMCKT *dsim)   {   
    instance = inst;    
          ckt = dsim;     
        
//		instance->log("START");
    hProcessHeap=GetProcessHeap();
  
	takt=0x0;
	mode_reg=0x0;
	status_reg=0x0;
	cnt_cs=0;
	ch_adr0[0]=0;ch_adr0[1]=0;
	ch_cnt0[0]=0;ch_cnt0[1]=0;
	ch_adr1[0]=0;ch_adr1[1]=0;
	ch_cnt1[0]=0;ch_cnt1[1]=0;
	ch_adr2[0]=0;ch_adr2[1]=0;
	ch_cnt2[0]=0;ch_cnt2[1]=0;
	ch_adr3[0]=0;ch_adr3[1]=0;
	ch_cnt3[0]=0;ch_cnt3[1]=0;

    pin_CLK = instance->getdsimpin("CCLK", true);		pin_CLK->setstate(0,1,FLT);   
    pin_cs = instance->getdsimpin("$CS$", true);		pin_cs->setstate(0,1,FLT);   
    pin_nIORd = instance->getdsimpin("$IOR$", true);	pin_nIORd->setstate(0,1,FLT);   
    pin_nIOWr = instance->getdsimpin("$IOW$", true);	pin_nIOWr->setstate(0,1,FLT);   
    pin_nMEMR = instance->getdsimpin("$MEMR$", true);	pin_nMEMR->setstate(0,1,FLT);   
    pin_nMEMW = instance->getdsimpin("$MEMW$", true);	pin_nMEMW->setstate(0,1,FLT);   
    pin_reset = instance->getdsimpin("RST", true);		pin_reset->setstate(0,1,FLT);   
    pin_A0 = instance->getdsimpin("A0", true);
    pin_A1 = instance->getdsimpin("A1", true);
    pin_A2 = instance->getdsimpin("A2", true);
    pin_A3 = instance->getdsimpin("A3", true);
    pin_A4 = instance->getdsimpin("A4", true);
    pin_A5 = instance->getdsimpin("A5", true);
    pin_A6 = instance->getdsimpin("A6", true);
    pin_A7 = instance->getdsimpin("A7", true);   set_adr_Z(0);
    pin_ADSTB = instance->getdsimpin("ADSTB", true);	pin_ADSTB->setstate(0,1,SLO);
    pin_AEN = instance->getdsimpin("AEN", true);		pin_AEN->setstate(0,1,SLO);
    pin_D0 = instance->getdsimpin("D0", true);   
    pin_D1 = instance->getdsimpin("D1", true);   
    pin_D2 = instance->getdsimpin("D2", true);   
    pin_D3 = instance->getdsimpin("D3", true);   
    pin_D4 = instance->getdsimpin("D4", true);   
    pin_D5 = instance->getdsimpin("D5", true);   
    pin_D6 = instance->getdsimpin("D6", true);   
    pin_D7 = instance->getdsimpin("D7", true);   set_data_Z(0);
    pin_DRQ0 = instance->getdsimpin("DRQ0", true);		pin_DRQ0->setstate(0,1,FLT);
    pin_DRQ1 = instance->getdsimpin("DRQ1", true);		pin_DRQ1->setstate(0,1,FLT);
    pin_DRQ2 = instance->getdsimpin("DRQ2", true);		pin_DRQ2->setstate(0,1,FLT);
    pin_DRQ3 = instance->getdsimpin("DRQ3", true);		pin_DRQ3->setstate(0,1,FLT);
    pin_nDACK0 = instance->getdsimpin("$DACK0$", true);	pin_nDACK0->setstate(0,1,SHI);
    pin_nDACK1 = instance->getdsimpin("$DACK1$", true);	pin_nDACK1->setstate(0,1,SHI);
    pin_nDACK2 = instance->getdsimpin("$DACK2$", true);	pin_nDACK2->setstate(0,1,SHI);
    pin_nDACK3 = instance->getdsimpin("$DACK3$", true);	pin_nDACK3->setstate(0,1,SHI);
    pin_HOLD = instance->getdsimpin("HRQ", true);		pin_HOLD->setstate(0,1,SLO);
    pin_HLDA = instance->getdsimpin("HLDA", true);		pin_HLDA->setstate(0,1,FLT);
    pin_TC   = instance->getdsimpin("TC", true);		pin_TC->setstate(0,1,SLO);    
}   
       
void I8257::runctrl(RUNMODES mode)  {   

}   
       
       
void I8257::actuate(REALTIME time,ACTIVESTATE newstate) {   

}   
       
BOOL I8257::indicate(REALTIME time,ACTIVEDATA *data)   {      
	return TRUE;
}   
       
void I8257::set_data_Z(ABSTIME time)
{
 pin_D0->setstate(time,1,FLT);   
 pin_D1->setstate(time,1,FLT);   
 pin_D2->setstate(time,1,FLT);   
 pin_D3->setstate(time,1,FLT);   
 pin_D4->setstate(time,1,FLT);   
 pin_D5->setstate(time,1,FLT);   
 pin_D6->setstate(time,1,FLT);   
 pin_D7->setstate(time,1,FLT);   
}

void I8257::set_adr_Z(ABSTIME time)
{
 pin_A0->setstate(time,1,FLT);   
 pin_A1->setstate(time,1,FLT);   
 pin_A2->setstate(time,1,FLT);   
 pin_A3->setstate(time,1,FLT);   
 pin_A4->setstate(time,1,FLT);   
 pin_A5->setstate(time,1,FLT);   
 pin_A6->setstate(time,1,FLT);   
 pin_A7->setstate(time,1,FLT);   
}

unsigned char I8257::get_data()
{
unsigned char tmp=0;
 if (ishigh(pin_D0->istate())) tmp|=0x01;
 if (ishigh(pin_D1->istate())) tmp|=0x02;
 if (ishigh(pin_D2->istate())) tmp|=0x04;
 if (ishigh(pin_D3->istate())) tmp|=0x08;
 if (ishigh(pin_D4->istate())) tmp|=0x10;
 if (ishigh(pin_D5->istate())) tmp|=0x20;
 if (ishigh(pin_D6->istate())) tmp|=0x40;
 if (ishigh(pin_D7->istate())) tmp|=0x80;
 return tmp;
}

void I8257::set_data(ABSTIME time,unsigned char tmp)
{
	if (tmp&0x01) pin_D0->setstate(time,1,SHI); else pin_D0->setstate(time,1,SLO);
	if (tmp&0x02) pin_D1->setstate(time,1,SHI); else pin_D1->setstate(time,1,SLO);
	if (tmp&0x04) pin_D2->setstate(time,1,SHI); else pin_D2->setstate(time,1,SLO);
	if (tmp&0x08) pin_D3->setstate(time,1,SHI); else pin_D3->setstate(time,1,SLO);
	if (tmp&0x10) pin_D4->setstate(time,1,SHI); else pin_D4->setstate(time,1,SLO);
	if (tmp&0x20) pin_D5->setstate(time,1,SHI); else pin_D5->setstate(time,1,SLO);
	if (tmp&0x40) pin_D6->setstate(time,1,SHI); else pin_D6->setstate(time,1,SLO);
	if (tmp&0x80) pin_D7->setstate(time,1,SHI); else pin_D7->setstate(time,1,SLO);
}

void I8257::set_adr(ABSTIME time,unsigned char tmp)
{
	if (tmp&0x01) pin_A0->setstate(time,1,SHI); else pin_A0->setstate(time,1,SLO);
	if (tmp&0x02) pin_A1->setstate(time,1,SHI); else pin_A1->setstate(time,1,SLO);
	if (tmp&0x04) pin_A2->setstate(time,1,SHI); else pin_A2->setstate(time,1,SLO);
	if (tmp&0x08) pin_A3->setstate(time,1,SHI); else pin_A3->setstate(time,1,SLO);
	if (tmp&0x10) pin_A4->setstate(time,1,SHI); else pin_A4->setstate(time,1,SLO);
	if (tmp&0x20) pin_A5->setstate(time,1,SHI); else pin_A5->setstate(time,1,SLO);
	if (tmp&0x40) pin_A6->setstate(time,1,SHI); else pin_A6->setstate(time,1,SLO);
	if (tmp&0x80) pin_A7->setstate(time,1,SHI); else pin_A7->setstate(time,1,SLO);
}

void I8257::simulate (ABSTIME time,DSIMMODES mode) {      
unsigned char tmp=0,dtmp;
unsigned char mask[8]={0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80};

//	if (pin_reset->isactive()) //ToDo
if (pin_cs->isinactive()&(pin_nIOWr->isedge()|pin_nIOWr->isinactive())&(takt==0)&pin_HLDA->isinactive())
	 {// dma is inacktiv, so setup internal regs...
		  if (ishigh(pin_A0->istate())) tmp|=0x01;
		  if (ishigh(pin_A1->istate())) tmp|=0x02;
		  if (ishigh(pin_A2->istate())) tmp|=0x04;
		  if (ishigh(pin_A3->istate())) tmp|=0x08;
		   if (pin_nIORd->isnegedge())
			{//read internal regs 
				//ToDo
			}
			else
			 if (pin_nIOWr->isposedge())
			  {//write internal regs 
		       dtmp=get_data();
			   instance->log("i8257: write reg %x  d %x",tmp,dtmp);
			   if (tmp==0x08) { mode_reg=dtmp; cnt_cs=0; }//instance->log(" reg 4 %x  reg5 %x",ch_adr2[1]*256+ch_adr2[0],ch_cnt2[1]*256+ch_cnt2[0]);}
			    else
			    {
			     switch(tmp&0x07)
			     {
			      case 0: ch_adr0[cnt_cs]=dtmp;  break;
			      case 1: ch_cnt0[cnt_cs]=dtmp;  break;
			      case 2: ch_adr1[cnt_cs]=dtmp;  break;
			      case 3: ch_cnt1[cnt_cs]=dtmp;  break;
			      case 4: ch_adr2[cnt_cs]=dtmp; if (mode_reg&0x80) ch_adr3[cnt_cs]=dtmp; break; //if autoload set...
			      case 5: ch_cnt2[cnt_cs]=dtmp; if (mode_reg&0x80) ch_cnt3[cnt_cs]=dtmp; break; //if autoload set...
			      case 6: ch_adr3[cnt_cs]=dtmp;  break;
			      case 7: ch_cnt3[cnt_cs]=dtmp;  break;
			     }
			     cnt_cs++; cnt_cs&=0x01;
			    }
			 }
	  return;
	}//end if ((pin_cs->isinactive())&(takt==0))

	if (pin_CLK->isedge())
	{
//  instance->log("i8257 1");
	 if (!takt)
	 {
//  instance->log("i8257 2");
	  if ((mode_reg&0x0f)==0) return;
//  instance->log("i8257 0");
	  if (pin_DRQ0->isactive()|pin_DRQ1->isactive()|pin_DRQ2->isactive()|pin_DRQ3->isactive()|pin_HOLD->isactive())
	  {
//  instance->log("i8257 1");
		if (pin_CLK->isposedge()) {pin_HOLD->setstate(time,1,SHI); /* instance->log("i8257 2");*/}
		if (pin_CLK->isnegedge() & pin_HLDA->isactive()) {takt=1;  /* instance->log("i8257 3");*/}
//  instance->log("i8257 4");
	  }//end if (pin_DRQ0->isactive()|pin_DRQ1->isactive()|pin_DRQ2->isactive()|pin_DRQ3->isactive())
	 }// end if (!takt)
	 if (takt)
	 {
//  instance->log("i8257 5   %d",takt);
	  switch(takt)
	  {
	  case 1://             CLK -\_		S1
		pin_AEN->setstate(time,1,SHI);
		break;
	  case 2://             CLK _/-
		pin_ADSTB->setstate(time,1,SHI);
		set_data(time,ch_adr2[1]);//ToDo - only dma2 channel...
		set_adr(time,ch_adr2[0]);
		break;
	  case 3://             CLK -\_		S2
		pin_nDACK2->setstate(time,1,SLO);
		break;
	  case 4://             CLK _/-
		pin_ADSTB->setstate(time,1,SLO);
		break;
	  case 5://             CLK -\_		S3
		set_data_Z(time);
		pin_nIORd->setstate(time,1,SLO);
		if (mode_reg&0x20) pin_nMEMW->setstate(time,1,SLO);
		break;
	  case 6://             CLK _/-
		pin_nMEMW->setstate(time,1,SLO);
		if ((((unsigned short)ch_cnt2[1]&0x3f)*256+ch_cnt2[0])==0) pin_TC->setstate(time,1,SHI);
		break;
	  case 7://             CLK -\_		s4
		break;
	  case 8://             CLK _/-
		pin_nMEMW->setstate(time,1,SHI);
		pin_nIORd->setstate(time,1,SHI);//?
		if ((((unsigned short)ch_cnt2[1]&0x3f)*256+ch_cnt2[0])==0) pin_TC->setstate(time,1,SLO);
		break;
//	  case 10://            CLK -\_		s1 n
	  case 9://             CLK -\_		s1 n
		if (!(pin_DRQ0->isactive()|pin_DRQ1->isactive()|pin_DRQ2->isactive()|pin_DRQ3->isactive()))
		{pin_HOLD->setstate(time,1,SLO); takt=10;}
//?		pin_nIORd->setstate(time,1,SHI);
		pin_nDACK2->setstate(time,1,SHI);
		ch_adr2[0]++;
		if (ch_adr2[0]==0) ch_adr2[1]++;
 // instance->log("i8257 4   %x  %x",ch_adr2[1],ch_adr2[0]);
		if ((((unsigned short)ch_cnt2[1]&0x3f)*256+ch_cnt2[0])!=0)
		{
 // instance->log("i8257 5   %x  %x",ch_cnt2[1],ch_cnt2[0]);
		 if (takt!=10) takt=1;
		 ch_cnt2[0]--;
		 if (ch_cnt2[0]==0xff) {tmp=ch_cnt2[1]&0xc0; ch_cnt2[1]=(ch_cnt2[1]&0x3f)-1; ch_cnt2[1]=ch_cnt2[1]&0x3f+tmp;}
		}
		else 
		{
		  if (takt!=10) takt=0; else takt=11;
		  if (mode_reg&0x80) {ch_adr2[0]=ch_adr3[0]; ch_adr2[1]=ch_adr3[1]; ch_cnt2[0]=ch_cnt3[0]; ch_cnt2[1]=ch_cnt3[1];}
		  return;
		}
		if (takt==10) {takt=11; return;}
		break;
	  case 11://             CLK _/-
		  pin_AEN->setstate(time,1,SLO);
		  set_data_Z(time);
		  set_adr_Z(time);
		  takt=0; 
		  return;
		break;
	  }
	  takt++;
	 }//end if (takt)
	}//end if (pin_CLK->isedge())
}   
       
      
void I8257::callback(ABSTIME time,EVENTID eventid)   {   

}   
              
extern "C" IACTIVEMODEL __declspec(dllexport)*createactivemodel(CHAR *device,ILICENCESERVER *ils)  {    
        ils->authorize (0);     
        return new I8257;   
}   
              
extern "C" VOID  __declspec(dllexport)deleteactivemodel (IACTIVEMODEL *model)  {    
    
    
  delete (I8257*)model;   
}   
               
void I8257::initialize(ICOMPONENT *cpt)  {    

}   
               
ISPICEMODEL *I8257::getspicemodel(CHAR *)  {    
        return NULL;    
}   
       
IDSIMMODEL  *I8257::getdsimmodel(CHAR *)  {      
        return this;    
}   

void I8257::plot(ACTIVESTATE state)  {   

//	MessageBox(0, "plot", "Break", MB_OK);
}
        
void I8257::animate(INT element, ACTIVEDATA *data)  {    
//	MessageBox(0, "animate", "Break", MB_OK);

}   

BOOL I8257::actuate(WORD key, INT x, INT y, DWORD flags)  {
//	MessageBox(0, "ACTUATE2", "Break", MB_OK);
        return FALSE;    
}  
